// Code generated by SQLBoiler (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package postgres

import (
	"bytes"
	"context"
	"reflect"
	"testing"

	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/randomize"
	"github.com/volatiletech/sqlboiler/strmangle"
)

var (
	// Relationships sometimes use the reflection helper queries.Equal/queries.Assign
	// so force a package dependency in case they don't.
	_ = queries.Equal
)

func testOrderDeals(t *testing.T) {
	t.Parallel()

	query := OrderDeals()

	if query.Query == nil {
		t.Error("expected a query, got nothing")
	}
}

func testOrderDealsDelete(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := o.Delete(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := OrderDeals().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testOrderDealsQueryDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := OrderDeals().DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := OrderDeals().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testOrderDealsSliceDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := OrderDealSlice{o}

	if rowsAff, err := slice.DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := OrderDeals().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testOrderDealsExists(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	e, err := OrderDealExists(ctx, tx, o.ID)
	if err != nil {
		t.Errorf("Unable to check if OrderDeal exists: %s", err)
	}
	if !e {
		t.Errorf("Expected OrderDealExists to return true, but got false.")
	}
}

func testOrderDealsFind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	orderDealFound, err := FindOrderDeal(ctx, tx, o.ID)
	if err != nil {
		t.Error(err)
	}

	if orderDealFound == nil {
		t.Error("want a record, got nil")
	}
}

func testOrderDealsBind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = OrderDeals().Bind(ctx, tx, o); err != nil {
		t.Error(err)
	}
}

func testOrderDealsOne(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if x, err := OrderDeals().One(ctx, tx); err != nil {
		t.Error(err)
	} else if x == nil {
		t.Error("expected to get a non nil record")
	}
}

func testOrderDealsAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	orderDealOne := &OrderDeal{}
	orderDealTwo := &OrderDeal{}
	if err = randomize.Struct(seed, orderDealOne, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}
	if err = randomize.Struct(seed, orderDealTwo, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = orderDealOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = orderDealTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := OrderDeals().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 2 {
		t.Error("want 2 records, got:", len(slice))
	}
}

func testOrderDealsCount(t *testing.T) {
	t.Parallel()

	var err error
	seed := randomize.NewSeed()
	orderDealOne := &OrderDeal{}
	orderDealTwo := &OrderDeal{}
	if err = randomize.Struct(seed, orderDealOne, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}
	if err = randomize.Struct(seed, orderDealTwo, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = orderDealOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = orderDealTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := OrderDeals().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 2 {
		t.Error("want 2 records, got:", count)
	}
}

func orderDealBeforeInsertHook(ctx context.Context, e boil.ContextExecutor, o *OrderDeal) error {
	*o = OrderDeal{}
	return nil
}

func orderDealAfterInsertHook(ctx context.Context, e boil.ContextExecutor, o *OrderDeal) error {
	*o = OrderDeal{}
	return nil
}

func orderDealAfterSelectHook(ctx context.Context, e boil.ContextExecutor, o *OrderDeal) error {
	*o = OrderDeal{}
	return nil
}

func orderDealBeforeUpdateHook(ctx context.Context, e boil.ContextExecutor, o *OrderDeal) error {
	*o = OrderDeal{}
	return nil
}

func orderDealAfterUpdateHook(ctx context.Context, e boil.ContextExecutor, o *OrderDeal) error {
	*o = OrderDeal{}
	return nil
}

func orderDealBeforeDeleteHook(ctx context.Context, e boil.ContextExecutor, o *OrderDeal) error {
	*o = OrderDeal{}
	return nil
}

func orderDealAfterDeleteHook(ctx context.Context, e boil.ContextExecutor, o *OrderDeal) error {
	*o = OrderDeal{}
	return nil
}

func orderDealBeforeUpsertHook(ctx context.Context, e boil.ContextExecutor, o *OrderDeal) error {
	*o = OrderDeal{}
	return nil
}

func orderDealAfterUpsertHook(ctx context.Context, e boil.ContextExecutor, o *OrderDeal) error {
	*o = OrderDeal{}
	return nil
}

func testOrderDealsHooks(t *testing.T) {
	t.Parallel()

	var err error

	ctx := context.Background()
	empty := &OrderDeal{}
	o := &OrderDeal{}

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, o, orderDealDBTypes, false); err != nil {
		t.Errorf("Unable to randomize OrderDeal object: %s", err)
	}

	AddOrderDealHook(boil.BeforeInsertHook, orderDealBeforeInsertHook)
	if err = o.doBeforeInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeInsertHook function to empty object, but got: %#v", o)
	}
	orderDealBeforeInsertHooks = []OrderDealHook{}

	AddOrderDealHook(boil.AfterInsertHook, orderDealAfterInsertHook)
	if err = o.doAfterInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterInsertHook function to empty object, but got: %#v", o)
	}
	orderDealAfterInsertHooks = []OrderDealHook{}

	AddOrderDealHook(boil.AfterSelectHook, orderDealAfterSelectHook)
	if err = o.doAfterSelectHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterSelectHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterSelectHook function to empty object, but got: %#v", o)
	}
	orderDealAfterSelectHooks = []OrderDealHook{}

	AddOrderDealHook(boil.BeforeUpdateHook, orderDealBeforeUpdateHook)
	if err = o.doBeforeUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpdateHook function to empty object, but got: %#v", o)
	}
	orderDealBeforeUpdateHooks = []OrderDealHook{}

	AddOrderDealHook(boil.AfterUpdateHook, orderDealAfterUpdateHook)
	if err = o.doAfterUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpdateHook function to empty object, but got: %#v", o)
	}
	orderDealAfterUpdateHooks = []OrderDealHook{}

	AddOrderDealHook(boil.BeforeDeleteHook, orderDealBeforeDeleteHook)
	if err = o.doBeforeDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeDeleteHook function to empty object, but got: %#v", o)
	}
	orderDealBeforeDeleteHooks = []OrderDealHook{}

	AddOrderDealHook(boil.AfterDeleteHook, orderDealAfterDeleteHook)
	if err = o.doAfterDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterDeleteHook function to empty object, but got: %#v", o)
	}
	orderDealAfterDeleteHooks = []OrderDealHook{}

	AddOrderDealHook(boil.BeforeUpsertHook, orderDealBeforeUpsertHook)
	if err = o.doBeforeUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpsertHook function to empty object, but got: %#v", o)
	}
	orderDealBeforeUpsertHooks = []OrderDealHook{}

	AddOrderDealHook(boil.AfterUpsertHook, orderDealAfterUpsertHook)
	if err = o.doAfterUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpsertHook function to empty object, but got: %#v", o)
	}
	orderDealAfterUpsertHooks = []OrderDealHook{}
}

func testOrderDealsInsert(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := OrderDeals().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testOrderDealsInsertWhitelist(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Whitelist(orderDealColumnsWithoutDefault...)); err != nil {
		t.Error(err)
	}

	count, err := OrderDeals().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testOrderDealToOneOrderUsingOrder(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local OrderDeal
	var foreign Order

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, orderDBTypes, false, orderColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Order struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.OrderID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Order().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := OrderDealSlice{&local}
	if err = local.L.LoadOrder(ctx, tx, false, (*[]*OrderDeal)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Order == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Order = nil
	if err = local.L.LoadOrder(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Order == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testOrderDealToOneOfferUsingOffer(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local OrderDeal
	var foreign Offer

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, offerDBTypes, false, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.OfferID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Offer().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := OrderDealSlice{&local}
	if err = local.L.LoadOffer(ctx, tx, false, (*[]*OrderDeal)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Offer == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Offer = nil
	if err = local.L.LoadOffer(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Offer == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testOrderDealToOneDriverUsingDriver(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local OrderDeal
	var foreign Driver

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, driverDBTypes, false, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.DriverID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Driver().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := OrderDealSlice{&local}
	if err = local.L.LoadDriver(ctx, tx, false, (*[]*OrderDeal)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Driver == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Driver = nil
	if err = local.L.LoadDriver(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Driver == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testOrderDealToOneSetOpOrderUsingOrder(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a OrderDeal
	var b, c Order

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, orderDealDBTypes, false, strmangle.SetComplement(orderDealPrimaryKeyColumns, orderDealColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, orderDBTypes, false, strmangle.SetComplement(orderPrimaryKeyColumns, orderColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, orderDBTypes, false, strmangle.SetComplement(orderPrimaryKeyColumns, orderColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Order{&b, &c} {
		err = a.SetOrder(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Order != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.OrderDeals[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.OrderID != x.ID {
			t.Error("foreign key was wrong value", a.OrderID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.OrderID))
		reflect.Indirect(reflect.ValueOf(&a.OrderID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if a.OrderID != x.ID {
			t.Error("foreign key was wrong value", a.OrderID, x.ID)
		}
	}
}
func testOrderDealToOneSetOpOfferUsingOffer(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a OrderDeal
	var b, c Offer

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, orderDealDBTypes, false, strmangle.SetComplement(orderDealPrimaryKeyColumns, orderDealColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, offerDBTypes, false, strmangle.SetComplement(offerPrimaryKeyColumns, offerColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, offerDBTypes, false, strmangle.SetComplement(offerPrimaryKeyColumns, offerColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Offer{&b, &c} {
		err = a.SetOffer(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Offer != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.OrderDeals[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.OfferID != x.ID {
			t.Error("foreign key was wrong value", a.OfferID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.OfferID))
		reflect.Indirect(reflect.ValueOf(&a.OfferID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if a.OfferID != x.ID {
			t.Error("foreign key was wrong value", a.OfferID, x.ID)
		}
	}
}
func testOrderDealToOneSetOpDriverUsingDriver(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a OrderDeal
	var b, c Driver

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, orderDealDBTypes, false, strmangle.SetComplement(orderDealPrimaryKeyColumns, orderDealColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Driver{&b, &c} {
		err = a.SetDriver(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Driver != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.OrderDeals[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.DriverID != x.ID {
			t.Error("foreign key was wrong value", a.DriverID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.DriverID))
		reflect.Indirect(reflect.ValueOf(&a.DriverID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if a.DriverID != x.ID {
			t.Error("foreign key was wrong value", a.DriverID, x.ID)
		}
	}
}

func testOrderDealsReload(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = o.Reload(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testOrderDealsReloadAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := OrderDealSlice{o}

	if err = slice.ReloadAll(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testOrderDealsSelect(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := OrderDeals().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 1 {
		t.Error("want one record, got:", len(slice))
	}
}

var (
	orderDealDBTypes = map[string]string{`ID`: `bigint`, `OrderID`: `bigint`, `OfferID`: `bigint`, `DriverID`: `bigint`, `Price`: `bigint`, `Rating`: `numeric`, `Completed`: `boolean`, `DTCreated`: `timestamp without time zone`, `DTUpdated`: `timestamp without time zone`}
	_                = bytes.MinRead
)

func testOrderDealsUpdate(t *testing.T) {
	t.Parallel()

	if 0 == len(orderDealPrimaryKeyColumns) {
		t.Skip("Skipping table with no primary key columns")
	}
	if len(orderDealColumns) == len(orderDealPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := OrderDeals().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	if rowsAff, err := o.Update(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only affect one row but affected", rowsAff)
	}
}

func testOrderDealsSliceUpdateAll(t *testing.T) {
	t.Parallel()

	if len(orderDealColumns) == len(orderDealPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &OrderDeal{}
	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := OrderDeals().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, orderDealDBTypes, true, orderDealPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	// Remove Primary keys and unique columns from what we plan to update
	var fields []string
	if strmangle.StringSliceMatch(orderDealColumns, orderDealPrimaryKeyColumns) {
		fields = orderDealColumns
	} else {
		fields = strmangle.SetComplement(
			orderDealColumns,
			orderDealPrimaryKeyColumns,
		)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	typ := reflect.TypeOf(o).Elem()
	n := typ.NumField()

	updateMap := M{}
	for _, col := range fields {
		for i := 0; i < n; i++ {
			f := typ.Field(i)
			if f.Tag.Get("boil") == col {
				updateMap[col] = value.Field(i).Interface()
			}
		}
	}

	slice := OrderDealSlice{o}
	if rowsAff, err := slice.UpdateAll(ctx, tx, updateMap); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("wanted one record updated but got", rowsAff)
	}
}

func testOrderDealsUpsert(t *testing.T) {
	t.Parallel()

	if len(orderDealColumns) == len(orderDealPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	// Attempt the INSERT side of an UPSERT
	o := OrderDeal{}
	if err = randomize.Struct(seed, &o, orderDealDBTypes, true); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Upsert(ctx, tx, false, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert OrderDeal: %s", err)
	}

	count, err := OrderDeals().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}

	// Attempt the UPDATE side of an UPSERT
	if err = randomize.Struct(seed, &o, orderDealDBTypes, false, orderDealPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize OrderDeal struct: %s", err)
	}

	if err = o.Upsert(ctx, tx, true, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert OrderDeal: %s", err)
	}

	count, err = OrderDeals().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}
}
